
PVector funMult(PVector z){
  PVector z1 = cMult(z,redballout.bpos);
  z1.div(scale);
   return(z1);
}

PVector funCropCorner(PVector z){
  PVector w = new PVector(redballout.bpos.x,redballout.bpos.y);
  w.sub(redballin.bpos);
  w.add(z);
   return(w);
}

class FourCorners{
PVector b, one, rea2, ma4, bma4, nose; 

FourCorners(){
	PVector a = toCenter( new PVector( width, height ));
	PVector a2 = cMult( a, a);
	rea2 = new PVector(-2 * a2.x, 0);
	ma4 = new PVector(a2.x*a2.x + a2.y*a2.y, 0);
	b = new PVector(1,0);
	bma4 = cMult( b, ma4);
	one = new PVector(1,0);
	nose = new PVector(0,0);
}

PVector out(PVector z){
	PVector w0 = toCenter( z );
	PVector w1 = subout(w0);	
	PVector w2 = fromCenter( w1 );
	return( w2 );
}

PVector subout(PVector z){
	PVector w0 = cAdd( z, nose);
	PVector w1 = cAdd( cMult( w0, w0), rea2 );
	PVector w2 = cAdd( cMult( w1, cMult( b, w0)), one);
	PVector w3 = cAdd( cMult( w2, w0 ), bma4);
	return( w3 );
}

void calcCons( PVector w ){
     PVector z = toCenter(w);
     nose = z;
     //println( "z = " + z );
     b = new PVector(1,0);
     //println( "b = " + b );
     bma4 = ma4;
     PVector pz = subout(z);
     //println( "pz = " + pz );
     pz = cAdd( pz, cNeg(z));
     //println( "ma4 = " + ma4 );
     //println( "pz = " + pz );
     //println( "1/pz = " + cInverse(pz) );
     b = cMult( cNeg(z), cInverse( pz ));
     bma4 = cMult( b, ma4);
     //println( "b = " + b );
}
}

class MoebiusFun{
      PVector a, b, c, d;

MoebiusFun( PVector va,PVector vb,PVector vc,PVector vd){
	    a = va;
	    b = vb;   
	    c = vc;
	    d = vd;
}

PVector out( PVector z){
	PVector num = cAdd( cMult(a,z), b);
	PVector den = cAdd( cMult(c,z), d);

	PVector res = cMult( num, cInverse(den) );
	return( res );
} 

void calcCons(  PVector in1, PVector in2, PVector in3, 
PVector out1, PVector out2, PVector out3){

MoebiusFun rat = new MoebiusFun(cAdd(out1,cNeg(out3)),
cMult(in2,cAdd(cNeg(out1),out3)),
cAdd(out2,cNeg(out3)),
cMult(in1,cAdd(cNeg(out2),out3)));
PVector r = rat.out(in3);
/*println("r = " + r);
println("a = " + rat.a);
println("b = " + rat.b);
println("c = " + rat.c);
println("d = " + rat.d);
println("in1 = " + in1);
println("out1 = " + out1);
println("in2 = " + in2);
println("out2 = " + out2);
println("in3 = " + in3);
println("out3 = " + out3);*/
a = cAdd( out1, cMult(cNeg(r),out2));
b = cAdd( cMult( r, cMult( in1, out2)), cNeg( cMult( in2, out1)));
c = cAdd(new PVector(1,0),cNeg(r));
d = cAdd( cMult( r, in1), cNeg(in2));
}
}


// class Poly4{
//     PVector[] a;

//     Poly4(){
// 	a = new PVector[5];
// 	for ( int i = 0; i < 5; i = i + 1 ){
// 	    a[i] = new PVector(0,0);
// 	}
//     }
//     Poly4( PVector[] cons){
// 	a = new PVector[5];
// 	for ( int i = 0; i < 5; i = i + 1 ){
// 	    a[i] = cons[i];
// 	}
//     }
//     PVector out( PVector z ){
// 	PVector result = new PVector(a[4].x,a[4].y);
// 	for ( int i = 3; i >= 0; i = i - 1 ){
// 	    result = cAdd( cMult( result, z ), a[i] );
// 	}
// 	return(result);
//     }
//     void calcConsFromZeros( PVector[] zeros){
// 	a[0] = cMult( cMult( zeros[0], zeros[1]), cMult( zeros[2], zeros[3]));
// 	a[1] = cNeg( cAdd( cAdd ( cMult( cMult( zeros[0], zeros[1]), zeros[2]),
// 				  cMult( cMult( zeros[0], zeros[1]), zeros[3])),
// 			   cAdd ( cMult( cMult( zeros[0], zeros[2]), zeros[3]),
// 				  cMult( cMult( zeros[1], zeros[2]), zeros[3]))));
// 	a[2] = cAdd( cAdd( cAdd( cMult( zeros[0], zeros[1]),
// 				 cMult( zeros[0], zeros[2])),
// 			   cAdd( cMult( zeros[0], zeros[3]),
// 				 cMult( zeros[1], zeros[2]))),
// 		     cAdd( cMult( zeros[1], zeros[3]),
// 			   cMult( zeros[2], zeros[3])));
// 	a[3] = cNeg( cAdd( cAdd( zeros[0], zeros[1]), 
// 			   cAdd( zeros[2], zeros[3])));
// 	a[4] = new PVector(1,0);			    
//     }
// }

class Polynomial{
    int degree;
    PVector[] a;

    Polynomial( int d ){
	degree = d;
	a = new PVector[d+1];
	for ( int i = 0; i <= d; i = i + 1 ){
	    a[i] = new PVector(0,0);
	}
    }
    Polynomial( int d, PVector[] cons ){
	degree = d;
	a = new PVector[d+1];
	for ( int i = 0; i <= d; i = i + 1 ){
	    a[i] = cons[i];
	}
    }
    PVector out( PVector z ){
	PVector result = new PVector(a[degree].x,a[degree].y);
	for ( int i = degree-1; i >= 0; i = i - 1 ){
	    result = cAdd( cMult( result, z ), a[i] );
	}
	return(result);
    }
    void calcConsFromZeros( PVector[] zeros){
	PVector[] coeffs = new PVector[ degree+1 ];
	coeffs[0] = new PVector(1,0);
	for ( int i = 1; i <= degree; i = i + 1 ){
	    coeffs[i] = new PVector(0,0);
	}
	a = calcCoeffsFromZeros( zeros, coeffs, 0);
    }
    PVector[] calcCoeffsFromZeros( PVector[] zeros, PVector[] coeffs, int n ){
	if ( n == zeros.length ){
	    return( coeffs );
	}
	PVector[] newcoeffs = new PVector[ zeros.length + 1 ];
	for ( int i = 0; i <= zeros.length; i = i + 1 ){
	    newcoeffs[i] = cMult( coeffs[i], cNeg( zeros[n] ));
	}
	for ( int i = 1; i <= zeros.length; i = i + 1 ){
	    newcoeffs[i] = cAdd( newcoeffs[i], coeffs[i-1] );
	}
	return( calcCoeffsFromZeros( zeros, newcoeffs, n+1 ));
    }
}




class FixFour{
    PVector b; 
    Polynomial zeroPoly;

    FixFour( PVector c1, PVector c2, PVector c3, PVector c4, 
		 PVector nosein,  PVector noseout){
	zeroPoly = new Polynomial( 4 );
	PVector origin = new PVector(0,0);
	PVector[] zeros = new PVector[4];
	zeros[0] = c1;
	zeros[1] = c2;
	zeros[2] = c3;
	zeros[3] = c4;
	zeroPoly.calcConsFromZeros( zeros );
	PVector pz0 = zeroPoly.out( nosein );
	if ( pz0 != origin ){
	    b = cMult( cAdd( noseout, cNeg( nosein )), cInverse( pz0 ));
	} else {
	    b = origin;
	}
    }

    PVector out(PVector z){
	return( cAdd( cMult( b, zeroPoly.out(z)), z));
    }
}

class FixThree{
    Polynomial zeroPoly, denom;

    FixThree( PVector c1, PVector c2, PVector c3, 
	      PVector inf1,  PVector inf2 ){
	zeroPoly = new Polynomial( 3 );
	PVector[] zeros = new PVector[3];
	zeros[0] = c1;
	zeros[1] = c2;
	zeros[2] = c3;
	zeroPoly.calcConsFromZeros( zeros );
	
	denom = new Polynomial( 2 );
	zeros = new PVector[2];
	zeros[0] = inf1;
	zeros[1] = inf2;
	denom.calcConsFromZeros( zeros );
    }
    FixThree( PVector c1, PVector c2, PVector c3, 
	      PVector in1,  PVector out1,
	      PVector in2, PVector out2 ){
	if ( in1.x == out1.x && in1.y == out1.y ){
	    if ( in2.x != out2.x || in2.y != out2.y ){
		//println("4 fixed points");
		zeroPoly = new Polynomial( 4 );
		PVector[] zeros = new PVector[4];
		zeros[0] = c1;
		zeros[1] = c2;
		zeros[2] = c3;
		zeros[3] = in1;
		zeroPoly.calcConsFromZeros( zeros );
	
		PVector[] conslist = new PVector[1];
	    
		conslist[0] = cMult( cNeg( zeroPoly.out(in2)),
				     cInverse( cAdd( out2, 
						     cNeg( in2))));
		denom = new Polynomial( 0, conslist);
		return;
	    } else {
		//println("5 fixed points");
		PVector[] conslist = new PVector[1];
		conslist[0] = new PVector(0,0);
		zeroPoly = new Polynomial( 0, conslist );
		conslist[0] = new PVector(1,0);
		denom = new Polynomial( 0, conslist );
		return;
	    }
	} else {
	    //println("3 fixed points");
	    zeroPoly = new Polynomial( 3 );
	    PVector[] zeros = new PVector[3];
	    zeros[0] = c1;
	    zeros[1] = c2;
	    zeros[2] = c3;
	    zeroPoly.calcConsFromZeros( zeros );

	    PVector[] conslist = new PVector[3];
	    PVector f1 = cMult( cNeg( zeroPoly.out(in1)),
				cInverse( cAdd( out1, cNeg( in1))));
	    PVector f2 = cMult( cNeg( zeroPoly.out(in2)),
				cInverse( cAdd( out2, cNeg( in2))));
	    PVector zsq1 = cMult( in1, in1);
	    PVector zsq2 = cMult( in2, in2);
	    conslist[2] = new PVector(-1,0);
	    conslist[1] = cMult( cAdd( cAdd( f1, cNeg(f2)),
				       cAdd( zsq1, cNeg(zsq2))),
				 cInverse( cAdd( in1, cNeg( in2))));
	    conslist[0] = cAdd( f1, cAdd( zsq1, 
					  cNeg( cMult( conslist[1], in1))));
	    denom = new Polynomial( 2, conslist);
	    return;
	}
    }

    PVector out(PVector z){
	PVector denVal =  denom.out(z);
	return( cMult( cAdd( cNeg( zeroPoly.out(z) ), 
			     cMult( z, denVal)),
		       cInverse( denVal )));
    }

}
